zoukankan      html  css  js  c++  java
  • (简单广搜) Ice Cave -- codeforces -- 540C

    http://codeforces.com/problemset/problem/540/C

     

    You play a computer game. Your character stands on some level of a multilevel ice cave. In order to move on forward, you need to descend one level lower and the only way to do this is to fall through the ice.

    The level of the cave where you are is a rectangular square grid of n rows and m columns. Each cell consists either from intact or from cracked ice. From each cell you can move to cells that are side-adjacent with yours (due to some limitations of the game engine you cannot make jumps on the same place, i.e. jump from a cell to itself). If you move to the cell with cracked ice, then your character falls down through it and if you move to the cell with intact ice, then the ice on this cell becomes cracked.

    Let's number the rows with integers from 1 to n from top to bottom and the columns with integers from 1 to m from left to right. Let's denote a cell on the intersection of the r-th row and the c-th column as (r, c).

    You are staying in the cell (r1, c1) and this cell is cracked because you've just fallen here from a higher level. You need to fall down through the cell (r2, c2) since the exit to the next level is there. Can you do this?

    Input

    The first line contains two integers, n and m (1 ≤ n, m ≤ 500) — the number of rows and columns in the cave description.

    Each of the next n lines describes the initial state of the level of the cave, each line consists of m characters "." (that is, intact ice) and "X" (cracked ice).

    The next line contains two integers, r1 and c1 (1 ≤ r1 ≤ n, 1 ≤ c1 ≤ m) — your initial coordinates. It is guaranteed that the description of the cave contains character 'X' in cell (r1, c1), that is, the ice on the starting cell is initially cracked.

    The next line contains two integers r2 and c2 (1 ≤ r2 ≤ n, 1 ≤ c2 ≤ m) — the coordinates of the cell through which you need to fall. The final cell may coincide with the starting one.

    Output

    If you can reach the destination, print 'YES', otherwise print 'NO'.

    Sample test(s)
    input
    4 6
    X...XX
    ...XX.
    .X..X.
    ......
    1 6
    2 2
    output
    YES
    input
    5 4
    .X..
    ...X
    X.X.
    ....
    .XX.
    5 3
    1 1
    output
    NO
    input
    4 7
    ..X.XX.
    .XX..X.
    X...X..
    X......
    2 2
    1 6
    output
    YES
    Note

    In the first sample test one possible path is:

    After the first visit of cell (2, 2) the ice on it cracks and when you step there for the second time, your character falls through the ice as intended.

     

     

    #include<iostream>
    #include<stdio.h>
    #include<string.h>
    #include<stdlib.h>
    #include<queue>
    using namespace std;
    
    #define N 550
    
    char G[N][N];
    int  a[N][N], n, m;
    int dir[4][2] = {{-1,0},{0,-1},{0,1},{1,0}};
    
    struct node
    {
        int x, y;
    }Start, End;
    
    int BFS()
    {
        int i;
        node p, q;
    
        queue<node>Q;
        Q.push(Start);
    
        ///a[Start.x][Start.y]--; 由于题意理解错误, 死在了这里
    
        while(Q.size())
        {
            p = Q.front(), Q.pop();
    
            for(i=0; i<4; i++)
            {
                q.x = p.x + dir[i][0];
                q.y = p.y + dir[i][1];
    
                if(q.x==End.x && q.y==End.y && a[q.x][q.y]==1) return 1;
    
                if(q.x>=0 && q.x<n && q.y>=0 && q.y<m && a[q.x][q.y]==2)
                {
                    a[q.x][q.y]--;
                    Q.push(q);
                }
            }
        }
    
        return 0;
    }
    
    int main()
    {
        int i, j;
        scanf("%d%d", &n, &m);
    
        memset(G, 0, sizeof(G));
        memset(a, 0, sizeof(a));
    
        for(i=0; i<n; i++)
        {
            scanf("%s", G[i]);
            for(j=0; j<m; j++)
            {
                if(G[i][j] == 'X')
                    a[i][j] = 1;
                if(G[i][j] == '.')
                    a[i][j] = 2;
            }
        }
    
        scanf("%d%d", &Start.x, &Start.y);
        scanf("%d%d", &End.x, &End.y);
    
        Start.x--, Start.y--;
        End.x--, End.y--;
    
        int ans = BFS();
    
        if(ans)
            printf("YES
    ");
        else
            printf("NO
    ");
    
        return 0;
    }

     

    勿忘初心
  • 相关阅读:
    C 语言指针小结
    NOIP2012 复赛考生须知!
    2012 NOIP 初赛复习指导
    16元的纸币
    记一次社会化的钓鱼攻击
    福州大学ACM代表队获36届ACMICPC全球总决赛第18名
    福州教育相关教育资源介绍
    世界末日:科普很重要啊~~~
    201212信息学奥林匹克竞赛,新生招募
    模拟人脑:这个事儿,闹大了
  • 原文地址:https://www.cnblogs.com/YY56/p/4977356.html
Copyright © 2011-2022 走看看